/**
 */
package de.mdelab.mlcallactions;

import org.eclipse.emf.ecore.EOperation;

import de.mdelab.mlexpressions.MLExpression;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>EOperation Call Action</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Invokes the specified eOperation on the object returned by thisParameterValue.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.EOperationCallAction#getThisParameterValue <em>This Parameter Value</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.EOperationCallAction#getEOperation <em>EOperation</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getEOperationCallAction()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='parametersMatchOperation'"
 * @generated
 */
public interface EOperationCallAction extends ParameterizedCallAction {
	/**
	 * Returns the value of the '<em><b>This Parameter Value</b></em>'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> If the method is not static, the result of
	 * thisParameterValue is used as the "this" parameter. <!-- end-model-doc
	 * -->
	 * 
	 * @return the value of the '<em>This Parameter Value</em>' containment
	 *         reference.
	 * @see #setThisParameterValue(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getEOperationCallAction_ThisParameterValue()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getThisParameterValue();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.EOperationCallAction#getThisParameterValue
	 * <em>This Parameter Value</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>This Parameter Value</em>'
	 *            containment reference.
	 * @see #getThisParameterValue()
	 * @generated
	 */
	void setThisParameterValue(MLExpression value);

	/**
	 * Returns the value of the '<em><b>EOperation</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EOperation</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>EOperation</em>' reference.
	 * @see #setEOperation(EOperation)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getEOperationCallAction_EOperation()
	 * @model required="true"
	 * @generated
	 */
	EOperation getEOperation();

	/**
	 * Sets the value of the '{@link de.mdelab.mlcallactions.EOperationCallAction#getEOperation <em>EOperation</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>EOperation</em>' reference.
	 * @see #getEOperation()
	 * @generated
	 */
	void setEOperation(EOperation value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'The provided parameters do not match the signature of eOperation \\\'\'.concat( self.eOperation.toString() ).concat( \'\\\'.\' ) ,\n\tstatus : Boolean = \n\t\tself.eOperation.eParameters-&gt;forAll( par | self.parameters-&gt;exists( par2 | par2.name = par.name) and self.parameters-&gt;any( par2 | par2.name = par.name ).type = par.eType)\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"EOperationCallAction::parametersMatchOperation\";\ntry {\n\t/**\n\t *\n\t * inv parametersMatchOperation:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = self.eOperation.eParameters-&gt;forAll(par |\n\t *             self.parameters-&gt;exists(par2 | par2.name = par.name) and\n\t *             self.parameters-&gt;any(par2 | par2.name = par.name).type = par.eType)\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{\n\t *               message = \'The provided parameters do not match the signature of eOperation \\\'\'.concat(\n\t *                 self.eOperation.toString())\n\t *               .concat(\'\\\'.\'), status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.EOPERATION_CALL_ACTION___PARAMETERS_MATCH_OPERATION__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_symbol_1;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EOperation%&gt; eOperation = this.getEOperation();\n\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%org.eclipse.emf.ecore.EParameter%&gt;&gt; eParameters = eOperation.getEParameters();\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.OrderedSetValue%&gt; BOXED_eParameters = idResolver.createOrderedSetOfAll(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.ORD_CLSSid_EParameter, eParameters);\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par = BOXED_eParameters.iterator();\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_par.hasNext()) {\n\t\t\t\t\tif (accumulator == null) {\n\t\t\t\t\t\tstatus = null;\n\t\t\t\t\t}\n\t\t\t\t\telse if (accumulator == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\tstatus = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EParameter%&gt; par = (&lt;%org.eclipse.emf.ecore.EParameter%&gt;)ITERATOR_par.next();\n\t\t\t\t/**\n\t\t\t\t *\n\t\t\t\t * self.parameters-&gt;exists(par2 | par2.name = par.name) and\n\t\t\t\t * self.parameters-&gt;any(par2 | par2.name = par.name).type = par.eType\n\t\t\t\t \052/\n\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_and;\n\t\t\t\ttry {\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.util.List%&gt;&lt;&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;&gt; parameters = this.getParameters();\n\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.OrderedSetValue%&gt; BOXED_parameters = idResolver.createOrderedSetOfAll(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.ORD_CLSSid_CallActionParameter, parameters);\n\t\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; accumulator_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par2 = BOXED_parameters.iterator();\n\t\t\t\t\t/*@NonInvalid\052/ &lt;%java.lang.Boolean%&gt; exists;\n\t\t\t\t\twhile (true) {\n\t\t\t\t\t\tif (!ITERATOR_par2.hasNext()) {\n\t\t\t\t\t\t\tif (accumulator_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)accumulator_0;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlcallactions.CallActionParameter%&gt; par2 = (&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;)ITERATOR_par2.next();\n\t\t\t\t\t\t/**\n\t\t\t\t\t\t * par2.name = par.name\n\t\t\t\t\t\t \052/\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name = par2.getName();\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_0 = par.getName();\n\t\t\t\t\t\tfinal /*@NonInvalid\052/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t\t\t\t\t//\n\t\t\t\t\t\tif (eq) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\texists = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (!eq) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\taccumulator_0 = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"exists\");\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; and;\n\t\t\t\t\tif (exists == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_eq_1;\n\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t&lt;%java.util.Iterator%&gt;&lt;&lt;%java.lang.Object%&gt;&gt; ITERATOR_par2_0 = BOXED_parameters.iterator();\n\t\t\t\t\t\t\t/*@Thrown\052/ &lt;%de.mdelab.mlcallactions.CallActionParameter%&gt; any;\n\t\t\t\t\t\t\twhile (true) {\n\t\t\t\t\t\t\t\tif (!ITERATOR_par2_0.hasNext()) {\n\t\t\t\t\t\t\t\t\tthrow new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(\"Nothing to return for \'\'any\'\'\");\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t/*@NonInvalid\052/ &lt;%de.mdelab.mlcallactions.CallActionParameter%&gt; par2_0 = (&lt;%de.mdelab.mlcallactions.CallActionParameter%&gt;)ITERATOR_par2_0.next();\n\t\t\t\t\t\t\t\t/**\n\t\t\t\t\t\t\t\t * par2.name = par.name\n\t\t\t\t\t\t\t\t \052/\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_1 = par2_0.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; name_2 = par.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ boolean eq_0 = (name_1 != null) ? name_1.equals(name_2) : (name_2 == null);\n\t\t\t\t\t\t\t\t//\n\t\t\t\t\t\t\t\tif (eq_0) {\t\t\t// Carry on till something found\n\t\t\t\t\t\t\t\t\tany = par2_0;\n\t\t\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = any.getType();\n\t\t\t\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; eType = par.getEType();\n\t\t\t\t\t\t\tfinal /*@Thrown\052/ boolean eq_1 = (type != null) ? type.equals(eType) : (eType == null);\n\t\t\t\t\t\t\tCAUGHT_eq_1 = eq_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\t\tCAUGHT_eq_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t\t}\n\t\t\t\t\t\tif (CAUGHT_eq_1 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tif (CAUGHT_eq_1 instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\n\t\t\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)CAUGHT_eq_1;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif (exists == null) {\n\t\t\t\t\t\t\t\tand = null;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tand = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tCAUGHT_and = and;\n\t\t\t\t}\n\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\tCAUGHT_and = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t//\n\t\t\t\tif (CAUGHT_and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\tstatus = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\tif (accumulator == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\taccumulator = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\taccumulator = CAUGHT_and;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator = new &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;(&lt;%org.eclipse.ocl.pivot.messages.PivotMessages%&gt;.NonBooleanBody, \"forAll\");\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@Thrown\052/ boolean eq_2 = status == Boolean.TRUE;\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\t\tif (eq_2) {\n\t\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; toString = &lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%&gt;.INSTANCE.evaluate(eOperation);\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; concat = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_The_32_provided_32_parameters_32_do_32_not_32_match_32_the_32_signature_32_of_32_eOperation, toString);\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%java.lang.String%&gt; concat_0 = &lt;%org.eclipse.ocl.pivot.library.string.StringConcatOperation%&gt;.INSTANCE.evaluate(concat, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR__39_);\n\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, concat_0, status);\n\t\t\t\tsymbol_1 = symbol_0;\n\t\t\t}\n\t\t\tCAUGHT_symbol_1 = symbol_1;\n\t\t}\n\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\tCAUGHT_symbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, CAUGHT_symbol_1, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean parametersMatchOperation(DiagnosticChain diagnostics, Map<Object, Object> context);

} // EOperationCallAction
