/**
 */
package de.mdelab.mlcallactions;

import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>New Object Action</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Creates a new object of the specified type. If the type is an EClass, the appropriate factory is used and no parameters have to be present. If the type is an EDataType, the parameters are used to select the appropriate constructor.
 * <!-- end-model-doc -->
 *
 *
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getNewObjectAction()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='typeNotAbstract'"
 * @generated
 */
public interface NewObjectAction extends ParameterizedCallAction {

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type &lt;&gt; null\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"NewObjectAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type &lt;&gt; null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.NEW_OBJECT_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = this.getType();\n\t\tfinal /*@NonInvalid\052/ boolean status = type != null;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean typeSpecified(DiagnosticChain diagnostics, Map<Object, Object> context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'type must not be abstract.\',\n\tstatus : Boolean = \n\t\tif self.type &lt;&gt; null then\n\t\t\tif self.type.oclIsKindOf( ecore::EClass ) then\n\t\t\t\tnot self.type.oclAsType( ecore::EClass ).abstract\n\t\t\telse\n\t\t\t\tnull\n\t\t\tendif\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"NewObjectAction::typeNotAbstract\";\ntry {\n\t/**\n\t *\n\t * inv typeNotAbstract:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.type &lt;&gt; null\n\t *           then\n\t *             if self.type.oclIsKindOf(ecore::EClass)\n\t *             then not self.type.oclAsType(ecore::EClass).abstract\n\t *             else null\n\t *             endif\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must not be abstract.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.ids.IdResolver%&gt; idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.NEW_OBJECT_ACTION___TYPE_NOT_ABSTRACT__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_4;\n\tif (le) {\n\t\tsymbol_4 = true;\n\t}\n\telse {\n\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_symbol_3;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = this.getType();\n\t\t\tfinal /*@NonInvalid\052/ boolean ne = type != null;\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; status;\n\t\t\tif (ne) {\n\t\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.Class%&gt; TYP_ecore_c_c_EClass = idResolver.getClass(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.CLSSid_EClass, null);\n\t\t\t\tfinal /*@Thrown\052/ boolean oclIsKindOf = &lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%&gt;.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass).booleanValue();\n\t\t\t\t/*@Thrown\052/ &lt;%java.lang.Boolean%&gt; symbol_1;\n\t\t\t\tif (oclIsKindOf) {\n\t\t\t\t\t/*@Caught\052/ &lt;%java.lang.Object%&gt; CAUGHT_symbol_0;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.emf.ecore.EClass%&gt; oclAsType = (&lt;%org.eclipse.emf.ecore.EClass%&gt;)&lt;%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%&gt;.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass);\n\t\t\t\t\t\tfinal /*@Thrown\052/ boolean symbol_0 = oclAsType.isAbstract();\n\t\t\t\t\t\tCAUGHT_symbol_0 = symbol_0;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\t\t\t\tCAUGHT_symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\tif (CAUGHT_symbol_0 instanceof &lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;) {\n\t\t\t\t\t\tthrow (&lt;%org.eclipse.ocl.pivot.values.InvalidValueException%&gt;)CAUGHT_symbol_0;\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown\052/ &lt;%java.lang.Boolean%&gt; not;\n\t\t\t\t\tif (CAUGHT_symbol_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE) {\n\t\t\t\t\t\tnot = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tif (CAUGHT_symbol_0 == &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE) {\n\t\t\t\t\t\t\tnot = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tnot = null;\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tsymbol_1 = not;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tsymbol_1 = null;\n\t\t\t\t}\n\t\t\t\tstatus = symbol_1;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tstatus = null;\n\t\t\t}\n\t\t\tfinal /*@Thrown\052/ boolean eq = status == Boolean.TRUE;\n\t\t\t/*@Thrown\052/ &lt;%java.lang.Object%&gt; symbol_3;\n\t\t\tif (eq) {\n\t\t\t\tsymbol_3 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@Thrown\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_2 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_type_32_must_32_not_32_be_32_abstract, status);\n\t\t\t\tsymbol_3 = symbol_2;\n\t\t\t}\n\t\t\tCAUGHT_symbol_3 = symbol_3;\n\t\t}\n\t\tcatch (&lt;%java.lang.Exception%&gt; e) {\n\t\t\tCAUGHT_symbol_3 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, CAUGHT_symbol_3, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_4 = logDiagnostic;\n\t}\n\treturn symbol_4;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean typeNotAbstract(DiagnosticChain diagnostics, Map<Object, Object> context);
} // NewObjectAction
