/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlexpressions.MLExpression;
import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Unary Operation Action</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Performs a unary operation on the operand.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.UnaryOperationAction#getOperator <em>Operator</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.UnaryOperationAction#getOperand <em>Operand</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getUnaryOperationAction()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='typeSpecified'"
 * @generated
 */
public interface UnaryOperationAction extends CallAction {
	/**
	 * Returns the value of the '<em><b>Operator</b></em>' attribute.
	 * The literals are from the enumeration {@link de.mdelab.mlcallactions.UnaryOperatorsEnum}.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operator</em>' attribute.
	 * @see de.mdelab.mlcallactions.UnaryOperatorsEnum
	 * @see #setOperator(UnaryOperatorsEnum)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getUnaryOperationAction_Operator()
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!UnaryOperationAction!operator'"
	 * @generated
	 */
	UnaryOperatorsEnum getOperator();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.UnaryOperationAction#getOperator
	 * <em>Operator</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Operator</em>' attribute.
	 * @see de.mdelab.mlcallactions.UnaryOperatorsEnum
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(UnaryOperatorsEnum value);

	/**
	 * Returns the value of the '<em><b>Operand</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operand</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operand</em>' containment reference.
	 * @see #setOperand(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getUnaryOperationAction_Operand()
	 * @model containment="true" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!UnaryOperationAction!operand'"
	 * @generated
	 */
	MLExpression getOperand();

	/**
	 * Sets the value of the '{@link de.mdelab.mlcallactions.UnaryOperationAction#getOperand <em>Operand</em>}' containment reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Operand</em>' containment reference.
	 * @see #getOperand()
	 * @generated
	 */
	void setOperand(MLExpression value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type &lt;&gt; null\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"UnaryOperationAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type &lt;&gt; null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlcallactions.MlcallactionsPackage%&gt;.Literals.UNARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.emf.ecore.EClassifier%&gt; type = this.getType();\n\t\tfinal /*@NonInvalid\052/ boolean status = type != null;\n\t\t/*@NonInvalid\052/ &lt;%java.lang.Object%&gt; symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.TupleValue%&gt; symbol_0 = &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.createTupleOfEach(&lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.TUPLid_, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, &lt;%de.mdelab.mlcallactions.MlcallactionsTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean typeSpecified(DiagnosticChain diagnostics, Map<Object, Object> context);

} // UnaryOperationAction
