/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.BinaryOperatorsEnum;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.MlcallactionsTables;
import de.mdelab.mlexpressions.MLExpression;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Binary Operation Action</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.impl.BinaryOperationActionImpl#getOperator <em>Operator</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.BinaryOperationActionImpl#getOperand1 <em>Operand1</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.BinaryOperationActionImpl#getOperand2 <em>Operand2</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BinaryOperationActionImpl extends CallActionImpl implements BinaryOperationAction {
	/**
	 * The default value of the '{@link #getOperator() <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOperator()
	 * @generated
	 * @ordered
	 */
	protected static final BinaryOperatorsEnum OPERATOR_EDEFAULT = BinaryOperatorsEnum.EQUALS;

	/**
	 * The cached value of the '{@link #getOperator() <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOperator()
	 * @generated
	 * @ordered
	 */
	protected BinaryOperatorsEnum operator = OPERATOR_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOperand1() <em>Operand1</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOperand1()
	 * @generated
	 * @ordered
	 */
	protected MLExpression operand1;

	/**
	 * The cached value of the '{@link #getOperand2() <em>Operand2</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOperand2()
	 * @generated
	 * @ordered
	 */
	protected MLExpression operand2;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected BinaryOperationActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlcallactionsPackage.Literals.BINARY_OPERATION_ACTION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BinaryOperatorsEnum getOperator() {
		return operator;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOperator(BinaryOperatorsEnum newOperator) {
		BinaryOperatorsEnum oldOperator = operator;
		operator = newOperator == null ? OPERATOR_EDEFAULT : newOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERATOR, oldOperator, operator));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getOperand1() {
		return operand1;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOperand1(MLExpression newOperand1, NotificationChain msgs) {
		MLExpression oldOperand1 = operand1;
		operand1 = newOperand1;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1, oldOperand1, newOperand1);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOperand1(MLExpression newOperand1) {
		if (newOperand1 != operand1) {
			NotificationChain msgs = null;
			if (operand1 != null)
				msgs = ((InternalEObject) operand1).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1, null, msgs);
			if (newOperand1 != null)
				msgs = ((InternalEObject) newOperand1).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1, null, msgs);
			msgs = basicSetOperand1(newOperand1, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1, newOperand1, newOperand1));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getOperand2() {
		return operand2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOperand2(MLExpression newOperand2, NotificationChain msgs) {
		MLExpression oldOperand2 = operand2;
		operand2 = newOperand2;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2, oldOperand2, newOperand2);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setOperand2(MLExpression newOperand2) {
		if (newOperand2 != operand2) {
			NotificationChain msgs = null;
			if (operand2 != null)
				msgs = ((InternalEObject) operand2).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2, null, msgs);
			if (newOperand2 != null)
				msgs = ((InternalEObject) newOperand2).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2, null, msgs);
			msgs = basicSetOperand2(newOperand2, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2, newOperand2, newOperand2));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean typeSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "BinaryOperationAction::typeSpecified";
		try {
			/**
			 *
			 * inv typeSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[1] = self.type <> null
			 *         in
			 *           if status = true
			 *           then true
			 *           else Tuple{message = 'type must be specified.', status = status}
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.BINARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ EClassifier type = this.getType();
				final /*@NonInvalid*/ boolean status = type != null;
				/*@NonInvalid*/ Object symbol_1;
				if (status) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_type_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1:
			return basicSetOperand1(null, msgs);
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2:
			return basicSetOperand2(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERATOR:
			return getOperator();
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1:
			return getOperand1();
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2:
			return getOperand2();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERATOR:
			setOperator((BinaryOperatorsEnum) newValue);
			return;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1:
			setOperand1((MLExpression) newValue);
			return;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2:
			setOperand2((MLExpression) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERATOR:
			setOperator(OPERATOR_EDEFAULT);
			return;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1:
			setOperand1((MLExpression) null);
			return;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2:
			setOperand2((MLExpression) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERATOR:
			return operator != OPERATOR_EDEFAULT;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND1:
			return operand1 != null;
		case MlcallactionsPackage.BINARY_OPERATION_ACTION__OPERAND2:
			return operand2 != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlcallactionsPackage.BINARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return typeSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (operator: ");
		result.append(operator);
		result.append(')');
		return result.toString();
	}

} // BinaryOperationActionImpl
