/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.MlcallactionsTables;
import de.mdelab.mlexpressions.MLExpression;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Method Call Action</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.impl.MethodCallActionImpl#getMethodName <em>Method Name</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.MethodCallActionImpl#getMethodClassName <em>Method Class Name</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.MethodCallActionImpl#getThisParameterValue <em>This Parameter Value</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MethodCallActionImpl extends ParameterizedCallActionImpl implements MethodCallAction {
	/**
	 * The default value of the '{@link #getMethodName() <em>Method Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMethodName()
	 * @generated
	 * @ordered
	 */
	protected static final String METHOD_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMethodName() <em>Method Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getMethodName()
	 * @generated
	 * @ordered
	 */
	protected String methodName = METHOD_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getMethodClassName() <em>Method Class Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getMethodClassName()
	 * @generated
	 * @ordered
	 */
	protected static final String METHOD_CLASS_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMethodClassName() <em>Method Class Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getMethodClassName()
	 * @generated
	 * @ordered
	 */
	protected String methodClassName = METHOD_CLASS_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getThisParameterValue()
	 * <em>This Parameter Value</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getThisParameterValue()
	 * @generated
	 * @ordered
	 */
	protected MLExpression thisParameterValue;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected MethodCallActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlcallactionsPackage.Literals.METHOD_CALL_ACTION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getMethodName() {
		return methodName;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMethodName(String newMethodName) {
		String oldMethodName = methodName;
		methodName = newMethodName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_NAME,
					oldMethodName, methodName));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getMethodClassName() {
		return methodClassName;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMethodClassName(String newMethodClassName) {
		String oldMethodClassName = methodClassName;
		methodClassName = newMethodClassName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_CLASS_NAME, oldMethodClassName, methodClassName));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getThisParameterValue() {
		return thisParameterValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetThisParameterValue(MLExpression newThisParameterValue, NotificationChain msgs) {
		MLExpression oldThisParameterValue = thisParameterValue;
		thisParameterValue = newThisParameterValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE, oldThisParameterValue,
					newThisParameterValue);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThisParameterValue(MLExpression newThisParameterValue) {
		if (newThisParameterValue != thisParameterValue) {
			NotificationChain msgs = null;
			if (thisParameterValue != null)
				msgs = ((InternalEObject) thisParameterValue).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE, null,
						msgs);
			if (newThisParameterValue != null)
				msgs = ((InternalEObject) newThisParameterValue).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE, null,
						msgs);
			msgs = basicSetThisParameterValue(newThisParameterValue, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE, newThisParameterValue,
					newThisParameterValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean methodClassNameSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "MethodCallAction::methodClassNameSpecified";
		try {
			/**
			 *
			 * inv methodClassNameSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[?] = self.methodClassName <> null and self.methodClassName <> ''
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'methodClassName must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.METHOD_CALL_ACTION___METHOD_CLASS_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ Boolean status;
				final /*@NonInvalid*/ String methodClassName = this.getMethodClassName();
				final /*@NonInvalid*/ boolean ne = !methodClassName.equals(MlcallactionsTables.STR_);
				status = ne;
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_methodClassName_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean methodNameSpecified(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "MethodCallAction::methodNameSpecified";
		try {
			/**
			 *
			 * inv methodNameSpecified:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let status : Boolean[?] = self.methodName <> null and self.methodName <> ''
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'methodName must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.METHOD_CALL_ACTION___METHOD_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ Boolean status;
				final /*@NonInvalid*/ String methodName = this.getMethodName();
				final /*@NonInvalid*/ boolean ne = !methodName.equals(MlcallactionsTables.STR_);
				status = ne;
				final /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
							MlcallactionsTables.STR_methodName_32_must_32_be_32_specified, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE:
			return basicSetThisParameterValue(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_NAME:
			return getMethodName();
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_CLASS_NAME:
			return getMethodClassName();
		case MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE:
			return getThisParameterValue();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_NAME:
			setMethodName((String) newValue);
			return;
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_CLASS_NAME:
			setMethodClassName((String) newValue);
			return;
		case MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE:
			setThisParameterValue((MLExpression) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_NAME:
			setMethodName(METHOD_NAME_EDEFAULT);
			return;
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_CLASS_NAME:
			setMethodClassName(METHOD_CLASS_NAME_EDEFAULT);
			return;
		case MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE:
			setThisParameterValue((MLExpression) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_NAME:
			return METHOD_NAME_EDEFAULT == null ? methodName != null : !METHOD_NAME_EDEFAULT.equals(methodName);
		case MlcallactionsPackage.METHOD_CALL_ACTION__METHOD_CLASS_NAME:
			return METHOD_CLASS_NAME_EDEFAULT == null ? methodClassName != null
					: !METHOD_CLASS_NAME_EDEFAULT.equals(methodClassName);
		case MlcallactionsPackage.METHOD_CALL_ACTION__THIS_PARAMETER_VALUE:
			return thisParameterValue != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlcallactionsPackage.METHOD_CALL_ACTION___METHOD_CLASS_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return methodClassNameSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlcallactionsPackage.METHOD_CALL_ACTION___METHOD_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP:
			return methodNameSpecified((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (methodName: ");
		result.append(methodName);
		result.append(", methodClassName: ");
		result.append(methodClassName);
		result.append(')');
		return result.toString();
	}

} // MethodCallActionImpl
