/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.BinaryOperatorsEnum;
import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.CloneAction;
import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.LiteralDeclarationAction;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.NewObjectAction;
import de.mdelab.mlcallactions.NullValueAction;
import de.mdelab.mlcallactions.ParameterizedCallAction;
import de.mdelab.mlcallactions.UnaryOperationAction;
import de.mdelab.mlcallactions.UnaryOperatorsEnum;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcallactions.VariableReferenceAction;
import de.mdelab.mlcallactions.util.MlcallactionsValidator;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlexpressions.MlexpressionsPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class MlcallactionsPackageImpl extends EPackageImpl implements MlcallactionsPackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callActionExpressionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass literalDeclarationActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableDeclarationActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableReferenceActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nullValueActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass unaryOperationActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass binaryOperationActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cloneActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callActionParameterEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass parameterizedCallActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass methodCallActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eOperationCallActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass newObjectActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eObjectReferenceActionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum unaryOperatorsEnumEEnum = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum binaryOperatorsEnumEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
	 * package package URI value.
	 * <p>
	 * Note: the correct way to create the package is via the static factory
	 * method {@link #init init()}, which also performs initialization of the
	 * package, or returns the registered package, if one already exists. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MlcallactionsPackageImpl() {
		super(eNS_URI, MlcallactionsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model,
	 * and for any others upon which it depends.
	 * 
	 * <p>
	 * This method is used to initialize {@link MlcallactionsPackage#eINSTANCE}
	 * when that field is accessed. Clients should not invoke it directly.
	 * Instead, they should simply access that field to obtain the package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MlcallactionsPackage init() {
		if (isInited)
			return (MlcallactionsPackage) EPackage.Registry.INSTANCE.getEPackage(MlcallactionsPackage.eNS_URI);

		// Obtain or create and register package
		Object registeredMlcallactionsPackage = EPackage.Registry.INSTANCE.get(eNS_URI);
		MlcallactionsPackageImpl theMlcallactionsPackage = registeredMlcallactionsPackage instanceof MlcallactionsPackageImpl
				? (MlcallactionsPackageImpl) registeredMlcallactionsPackage
				: new MlcallactionsPackageImpl();

		isInited = true;

		// Initialize simple dependencies
		MlcorePackage.eINSTANCE.eClass();
		MlexpressionsPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theMlcallactionsPackage.createPackageContents();

		// Initialize created meta-data
		theMlcallactionsPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put(theMlcallactionsPackage, new EValidator.Descriptor() {
			@Override
			public EValidator getEValidator() {
				return MlcallactionsValidator.INSTANCE;
			}
		});

		// Mark meta-data to indicate it can't be changed
		theMlcallactionsPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MlcallactionsPackage.eNS_URI, theMlcallactionsPackage);
		return theMlcallactionsPackage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCallActionExpression() {
		return callActionExpressionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCallActionExpression_CallActions() {
		return (EReference) callActionExpressionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCallAction() {
		return callActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getLiteralDeclarationAction() {
		return literalDeclarationActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getLiteralDeclarationAction_Literal() {
		return (EAttribute) literalDeclarationActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getLiteralDeclarationAction__TypeSpecified__DiagnosticChain_Map() {
		return literalDeclarationActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getLiteralDeclarationAction__LitteralNotNull__DiagnosticChain_Map() {
		return literalDeclarationActionEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getVariableDeclarationAction() {
		return variableDeclarationActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getVariableDeclarationAction_ValueExpression() {
		return (EReference) variableDeclarationActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getVariableDeclarationAction__NameSpecified__DiagnosticChain_Map() {
		return variableDeclarationActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getVariableDeclarationAction__TypeSpecified__DiagnosticChain_Map() {
		return variableDeclarationActionEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getVariableDeclarationAction__ValueExpressionSpecified__DiagnosticChain_Map() {
		return variableDeclarationActionEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getVariableReferenceAction() {
		return variableReferenceActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getVariableReferenceAction__TypeSpecified__DiagnosticChain_Map() {
		return variableReferenceActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getVariableReferenceAction__NameSpecified__DiagnosticChain_Map() {
		return variableReferenceActionEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getNullValueAction() {
		return nullValueActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getNullValueAction__TypeSpecified__DiagnosticChain_Map() {
		return nullValueActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getUnaryOperationAction() {
		return unaryOperationActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getUnaryOperationAction_Operator() {
		return (EAttribute) unaryOperationActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getUnaryOperationAction_Operand() {
		return (EReference) unaryOperationActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getUnaryOperationAction__TypeSpecified__DiagnosticChain_Map() {
		return unaryOperationActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getBinaryOperationAction() {
		return binaryOperationActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getBinaryOperationAction_Operator() {
		return (EAttribute) binaryOperationActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getBinaryOperationAction_Operand1() {
		return (EReference) binaryOperationActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getBinaryOperationAction_Operand2() {
		return (EReference) binaryOperationActionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getBinaryOperationAction__TypeSpecified__DiagnosticChain_Map() {
		return binaryOperationActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCloneAction() {
		return cloneActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCloneAction_ValueExpression() {
		return (EReference) cloneActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getCloneAction__TypeSpecified__DiagnosticChain_Map() {
		return cloneActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getCallActionParameter() {
		return callActionParameterEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCallActionParameter_ValueExpression() {
		return (EReference) callActionParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getCallActionParameter_CallAction() {
		return (EReference) callActionParameterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getCallActionParameter__NameSpecified__DiagnosticChain_Map() {
		return callActionParameterEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getCallActionParameter__TypeSpecified__DiagnosticChain_Map() {
		return callActionParameterEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getCallActionParameter__NameUnique__DiagnosticChain_Map() {
		return callActionParameterEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getParameterizedCallAction() {
		return parameterizedCallActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getParameterizedCallAction_Parameters() {
		return (EReference) parameterizedCallActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getMethodCallAction() {
		return methodCallActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMethodCallAction_MethodName() {
		return (EAttribute) methodCallActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EAttribute getMethodCallAction_MethodClassName() {
		return (EAttribute) methodCallActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getMethodCallAction_ThisParameterValue() {
		return (EReference) methodCallActionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getMethodCallAction__MethodClassNameSpecified__DiagnosticChain_Map() {
		return methodCallActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getMethodCallAction__MethodNameSpecified__DiagnosticChain_Map() {
		return methodCallActionEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEOperationCallAction() {
		return eOperationCallActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEOperationCallAction_ThisParameterValue() {
		return (EReference) eOperationCallActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEOperationCallAction_EOperation() {
		return (EReference) eOperationCallActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getEOperationCallAction__ParametersMatchOperation__DiagnosticChain_Map() {
		return eOperationCallActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getNewObjectAction() {
		return newObjectActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getNewObjectAction__TypeSpecified__DiagnosticChain_Map() {
		return newObjectActionEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getNewObjectAction__TypeNotAbstract__DiagnosticChain_Map() {
		return newObjectActionEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EClass getEObjectReferenceAction() {
		return eObjectReferenceActionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EReference getEObjectReferenceAction_EObject() {
		return (EReference) eObjectReferenceActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getUnaryOperatorsEnum() {
		return unaryOperatorsEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EEnum getBinaryOperatorsEnum() {
		return binaryOperatorsEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MlcallactionsFactory getMlcallactionsFactory() {
		return (MlcallactionsFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create classes and their features
		callActionExpressionEClass = createEClass(CALL_ACTION_EXPRESSION);
		createEReference(callActionExpressionEClass, CALL_ACTION_EXPRESSION__CALL_ACTIONS);

		callActionEClass = createEClass(CALL_ACTION);

		literalDeclarationActionEClass = createEClass(LITERAL_DECLARATION_ACTION);
		createEAttribute(literalDeclarationActionEClass, LITERAL_DECLARATION_ACTION__LITERAL);
		createEOperation(literalDeclarationActionEClass,
				LITERAL_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(literalDeclarationActionEClass,
				LITERAL_DECLARATION_ACTION___LITTERAL_NOT_NULL__DIAGNOSTICCHAIN_MAP);

		variableDeclarationActionEClass = createEClass(VARIABLE_DECLARATION_ACTION);
		createEReference(variableDeclarationActionEClass, VARIABLE_DECLARATION_ACTION__VALUE_EXPRESSION);
		createEOperation(variableDeclarationActionEClass,
				VARIABLE_DECLARATION_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(variableDeclarationActionEClass,
				VARIABLE_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(variableDeclarationActionEClass,
				VARIABLE_DECLARATION_ACTION___VALUE_EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		variableReferenceActionEClass = createEClass(VARIABLE_REFERENCE_ACTION);
		createEOperation(variableReferenceActionEClass,
				VARIABLE_REFERENCE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(variableReferenceActionEClass,
				VARIABLE_REFERENCE_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		nullValueActionEClass = createEClass(NULL_VALUE_ACTION);
		createEOperation(nullValueActionEClass, NULL_VALUE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		unaryOperationActionEClass = createEClass(UNARY_OPERATION_ACTION);
		createEAttribute(unaryOperationActionEClass, UNARY_OPERATION_ACTION__OPERATOR);
		createEReference(unaryOperationActionEClass, UNARY_OPERATION_ACTION__OPERAND);
		createEOperation(unaryOperationActionEClass, UNARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		binaryOperationActionEClass = createEClass(BINARY_OPERATION_ACTION);
		createEAttribute(binaryOperationActionEClass, BINARY_OPERATION_ACTION__OPERATOR);
		createEReference(binaryOperationActionEClass, BINARY_OPERATION_ACTION__OPERAND1);
		createEReference(binaryOperationActionEClass, BINARY_OPERATION_ACTION__OPERAND2);
		createEOperation(binaryOperationActionEClass, BINARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		cloneActionEClass = createEClass(CLONE_ACTION);
		createEReference(cloneActionEClass, CLONE_ACTION__VALUE_EXPRESSION);
		createEOperation(cloneActionEClass, CLONE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		callActionParameterEClass = createEClass(CALL_ACTION_PARAMETER);
		createEReference(callActionParameterEClass, CALL_ACTION_PARAMETER__VALUE_EXPRESSION);
		createEReference(callActionParameterEClass, CALL_ACTION_PARAMETER__CALL_ACTION);
		createEOperation(callActionParameterEClass, CALL_ACTION_PARAMETER___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(callActionParameterEClass, CALL_ACTION_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(callActionParameterEClass, CALL_ACTION_PARAMETER___NAME_UNIQUE__DIAGNOSTICCHAIN_MAP);

		parameterizedCallActionEClass = createEClass(PARAMETERIZED_CALL_ACTION);
		createEReference(parameterizedCallActionEClass, PARAMETERIZED_CALL_ACTION__PARAMETERS);

		methodCallActionEClass = createEClass(METHOD_CALL_ACTION);
		createEAttribute(methodCallActionEClass, METHOD_CALL_ACTION__METHOD_NAME);
		createEAttribute(methodCallActionEClass, METHOD_CALL_ACTION__METHOD_CLASS_NAME);
		createEReference(methodCallActionEClass, METHOD_CALL_ACTION__THIS_PARAMETER_VALUE);
		createEOperation(methodCallActionEClass, METHOD_CALL_ACTION___METHOD_CLASS_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(methodCallActionEClass, METHOD_CALL_ACTION___METHOD_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);

		eOperationCallActionEClass = createEClass(EOPERATION_CALL_ACTION);
		createEReference(eOperationCallActionEClass, EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE);
		createEReference(eOperationCallActionEClass, EOPERATION_CALL_ACTION__EOPERATION);
		createEOperation(eOperationCallActionEClass,
				EOPERATION_CALL_ACTION___PARAMETERS_MATCH_OPERATION__DIAGNOSTICCHAIN_MAP);

		newObjectActionEClass = createEClass(NEW_OBJECT_ACTION);
		createEOperation(newObjectActionEClass, NEW_OBJECT_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);
		createEOperation(newObjectActionEClass, NEW_OBJECT_ACTION___TYPE_NOT_ABSTRACT__DIAGNOSTICCHAIN_MAP);

		eObjectReferenceActionEClass = createEClass(EOBJECT_REFERENCE_ACTION);
		createEReference(eObjectReferenceActionEClass, EOBJECT_REFERENCE_ACTION__EOBJECT);

		// Create enums
		unaryOperatorsEnumEEnum = createEEnum(UNARY_OPERATORS_ENUM);
		binaryOperatorsEnumEEnum = createEEnum(BINARY_OPERATORS_ENUM);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model. This
	 * method is guarded to have no affect on any invocation but its first. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		MlexpressionsPackage theMlexpressionsPackage = (MlexpressionsPackage) EPackage.Registry.INSTANCE
				.getEPackage(MlexpressionsPackage.eNS_URI);
		MlcorePackage theMlcorePackage = (MlcorePackage) EPackage.Registry.INSTANCE.getEPackage(MlcorePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		callActionExpressionEClass.getESuperTypes().add(theMlexpressionsPackage.getMLExpression());
		callActionEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		callActionEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		callActionEClass.getESuperTypes().add(theMlcorePackage.getMLTypedElement());
		literalDeclarationActionEClass.getESuperTypes().add(this.getCallAction());
		variableDeclarationActionEClass.getESuperTypes().add(this.getCallAction());
		variableDeclarationActionEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		variableReferenceActionEClass.getESuperTypes().add(this.getCallAction());
		variableReferenceActionEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		nullValueActionEClass.getESuperTypes().add(this.getCallAction());
		unaryOperationActionEClass.getESuperTypes().add(this.getCallAction());
		binaryOperationActionEClass.getESuperTypes().add(this.getCallAction());
		cloneActionEClass.getESuperTypes().add(this.getCallAction());
		callActionParameterEClass.getESuperTypes().add(theMlcorePackage.getMLElementWithUUID());
		callActionParameterEClass.getESuperTypes().add(theMlcorePackage.getMLAnnotatedElement());
		callActionParameterEClass.getESuperTypes().add(theMlcorePackage.getMLNamedElement());
		callActionParameterEClass.getESuperTypes().add(theMlcorePackage.getMLTypedElement());
		parameterizedCallActionEClass.getESuperTypes().add(this.getCallAction());
		methodCallActionEClass.getESuperTypes().add(this.getParameterizedCallAction());
		eOperationCallActionEClass.getESuperTypes().add(this.getParameterizedCallAction());
		newObjectActionEClass.getESuperTypes().add(this.getParameterizedCallAction());
		eObjectReferenceActionEClass.getESuperTypes().add(this.getCallAction());

		// Initialize classes, features, and operations; add parameters
		initEClass(callActionExpressionEClass, CallActionExpression.class, "CallActionExpression", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCallActionExpression_CallActions(), this.getCallAction(), null, "callActions", null, 1, -1,
				CallActionExpression.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(callActionEClass, CallAction.class, "CallAction", IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		initEClass(literalDeclarationActionEClass, LiteralDeclarationAction.class, "LiteralDeclarationAction",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLiteralDeclarationAction_Literal(), ecorePackage.getEString(), "literal", null, 1, 1,
				LiteralDeclarationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = initEOperation(getLiteralDeclarationAction__TypeSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		EGenericType g1 = createEGenericType(ecorePackage.getEMap());
		EGenericType g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getLiteralDeclarationAction__LitteralNotNull__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "litteralNotNull", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(variableDeclarationActionEClass, VariableDeclarationAction.class, "VariableDeclarationAction",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getVariableDeclarationAction_ValueExpression(), theMlexpressionsPackage.getMLExpression(), null,
				"valueExpression", null, 1, 1, VariableDeclarationAction.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getVariableDeclarationAction__NameSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "nameSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getVariableDeclarationAction__TypeSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getVariableDeclarationAction__ValueExpressionSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "valueExpressionSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(variableReferenceActionEClass, VariableReferenceAction.class, "VariableReferenceAction",
				!IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getVariableReferenceAction__TypeSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getVariableReferenceAction__NameSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "nameSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(nullValueActionEClass, NullValueAction.class, "NullValueAction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getNullValueAction__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(unaryOperationActionEClass, UnaryOperationAction.class, "UnaryOperationAction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUnaryOperationAction_Operator(), this.getUnaryOperatorsEnum(), "operator", null, 1, 1,
				UnaryOperationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUnaryOperationAction_Operand(), theMlexpressionsPackage.getMLExpression(), null, "operand",
				null, 1, 1, UnaryOperationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getUnaryOperationAction__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(binaryOperationActionEClass, BinaryOperationAction.class, "BinaryOperationAction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBinaryOperationAction_Operator(), this.getBinaryOperatorsEnum(), "operator", null, 1, 1,
				BinaryOperationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBinaryOperationAction_Operand1(), theMlexpressionsPackage.getMLExpression(), null, "operand1",
				null, 1, 1, BinaryOperationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBinaryOperationAction_Operand2(), theMlexpressionsPackage.getMLExpression(), null, "operand2",
				null, 1, 1, BinaryOperationAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
				!IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getBinaryOperationAction__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(cloneActionEClass, CloneAction.class, "CloneAction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCloneAction_ValueExpression(), theMlexpressionsPackage.getMLExpression(), null,
				"valueExpression", null, 1, 1, CloneAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getCloneAction__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(callActionParameterEClass, CallActionParameter.class, "CallActionParameter", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCallActionParameter_ValueExpression(), theMlexpressionsPackage.getMLExpression(), null,
				"valueExpression", null, 1, 1, CallActionParameter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCallActionParameter_CallAction(), this.getParameterizedCallAction(),
				this.getParameterizedCallAction_Parameters(), "callAction", null, 1, 1, CallActionParameter.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getCallActionParameter__NameSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"nameSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getCallActionParameter__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getCallActionParameter__NameUnique__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"nameUnique", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(parameterizedCallActionEClass, ParameterizedCallAction.class, "ParameterizedCallAction", IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getParameterizedCallAction_Parameters(), this.getCallActionParameter(),
				this.getCallActionParameter_CallAction(), "parameters", null, 0, -1, ParameterizedCallAction.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(methodCallActionEClass, MethodCallAction.class, "MethodCallAction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMethodCallAction_MethodName(), ecorePackage.getEString(), "methodName", null, 1, 1,
				MethodCallAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEAttribute(getMethodCallAction_MethodClassName(), ecorePackage.getEString(), "methodClassName", null, 1, 1,
				MethodCallAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
				!IS_DERIVED, IS_ORDERED);
		initEReference(getMethodCallAction_ThisParameterValue(), theMlexpressionsPackage.getMLExpression(), null,
				"thisParameterValue", null, 0, 1, MethodCallAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
				IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getMethodCallAction__MethodClassNameSpecified__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "methodClassNameSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getMethodCallAction__MethodNameSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"methodNameSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(eOperationCallActionEClass, EOperationCallAction.class, "EOperationCallAction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEOperationCallAction_ThisParameterValue(), theMlexpressionsPackage.getMLExpression(), null,
				"thisParameterValue", null, 1, 1, EOperationCallAction.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEOperationCallAction_EOperation(), ecorePackage.getEOperation(), null, "eOperation", null, 1,
				1, EOperationCallAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getEOperationCallAction__ParametersMatchOperation__DiagnosticChain_Map(),
				ecorePackage.getEBoolean(), "parametersMatchOperation", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(newObjectActionEClass, NewObjectAction.class, "NewObjectAction", !IS_ABSTRACT, !IS_INTERFACE,
				IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getNewObjectAction__TypeSpecified__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeSpecified", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getNewObjectAction__TypeNotAbstract__DiagnosticChain_Map(), ecorePackage.getEBoolean(),
				"typeNotAbstract", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEMap());
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(eObjectReferenceActionEClass, EObjectReferenceAction.class, "EObjectReferenceAction", !IS_ABSTRACT,
				!IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEObjectReferenceAction_EObject(), ecorePackage.getEObject(), null, "eObject", null, 1, 1,
				EObjectReferenceAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
				IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(unaryOperatorsEnumEEnum, UnaryOperatorsEnum.class, "UnaryOperatorsEnum");
		addEEnumLiteral(unaryOperatorsEnumEEnum, UnaryOperatorsEnum.NOT);

		initEEnum(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.class, "BinaryOperatorsEnum");
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.EQUALS);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.GREATER_THAN);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.LESS_THAN);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.GREATER_OR_EQUALS);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.LESS_OR_EQUALS);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.NOT_EQUAL);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.AND);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.OR);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.ADD);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.SUBTRACT);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.MULTIPLY);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.DIVIDE);
		addEEnumLiteral(binaryOperatorsEnumEEnum, BinaryOperatorsEnum.MODULO);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/GenModel
		createGenModelAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";
		addAnnotation(this, source, new String[] {});
		addAnnotation(literalDeclarationActionEClass, source, new String[] { "constraints", "litteralNotNull" });
		addAnnotation(variableDeclarationActionEClass, source,
				new String[] { "constraints", "valueExpressionSpecified" });
		addAnnotation(variableReferenceActionEClass, source, new String[] { "constraints", "nameSpecified" });
		addAnnotation(nullValueActionEClass, source, new String[] { "constraints", "typeSpecified" });
		addAnnotation(unaryOperationActionEClass, source, new String[] { "constraints", "typeSpecified" });
		addAnnotation(binaryOperationActionEClass, source, new String[] { "constraints", "typeSpecified" });
		addAnnotation(cloneActionEClass, source, new String[] { "constraints", "typeSpecified" });
		addAnnotation(callActionParameterEClass, source, new String[] { "constraints", "nameUnique" });
		addAnnotation(methodCallActionEClass, source, new String[] { "constraints", "methodNameSpecified" });
		addAnnotation(eOperationCallActionEClass, source, new String[] { "constraints", "parametersMatchOperation" });
		addAnnotation(newObjectActionEClass, source, new String[] { "constraints", "typeNotAbstract" });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/GenModel</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createGenModelAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/GenModel";
		addAnnotation(callActionExpressionEClass, source, new String[] { "documentation",
				"A CallActionExpression contains CallActions. This is an expression language, where the AST is modelled directly be the user." });
		addAnnotation(getCallActionExpression_CallActions(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!CallActionExpression!callActions" });
		addAnnotation(callActionEClass, source,
				new String[] { "documentation", "Abstract superclass for all kinds of CallActions." });
		addAnnotation(literalDeclarationActionEClass, source,
				new String[] { "documentation", "Defines a literal of specific data type, e.g., String or Integer." });
		addAnnotation(getLiteralDeclarationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"LiteralDeclarationAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.LITERAL_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getLiteralDeclarationAction__LitteralNotNull__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"LiteralDeclarationAction::litteralNotNull\";\ntry {\n\t/**\n\t *\n\t * inv litteralNotNull:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[?] = self.literal <> null and self.literal <> \'\'\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'literal must not be null.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.LITERAL_DECLARATION_ACTION___LITTERAL_NOT_NULL__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> literal = this.getLiteral();\n\t\tfinal /*@NonInvalid*/ boolean ne = !literal.equals(<%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_);\n\t\tstatus = ne;\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_literal_32_must_32_not_32_be_32_null, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getLiteralDeclarationAction_Literal(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!LiteralDeclarationAction!literal" });
		addAnnotation(variableDeclarationActionEClass, source, new String[] { "documentation",
				"Declares a new variable and assigns the value returned by valueExpression." });
		addAnnotation(getVariableDeclarationAction__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"VariableDeclarationAction::nameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv nameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.name <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'name must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.VARIABLE_DECLARATION_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = this.getName();\n\t\tfinal /*@NonInvalid*/ boolean status = name != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_name_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getVariableDeclarationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"VariableDeclarationAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.VARIABLE_DECLARATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getVariableDeclarationAction__ValueExpressionSpecified__DiagnosticChain_Map(), source,
				new String[] { "body",
						"final <%java.lang.String%> constraintName = \"VariableDeclarationAction::valueExpressionSpecified\";\ntry {\n\t/**\n\t *\n\t * inv valueExpressionSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.valueExpression <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'valueExpression must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.VARIABLE_DECLARATION_ACTION___VALUE_EXPRESSION_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_0;\n\tif (le) {\n\t\tsymbol_0 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn symbol_0;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getVariableDeclarationAction_ValueExpression(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!VariableDeclarationAction!valueExpression" });
		addAnnotation(variableReferenceActionEClass, source,
				new String[] { "documentation", "References the variable with the specified name." });
		addAnnotation(getVariableReferenceAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"VariableReferenceAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.VARIABLE_REFERENCE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getVariableReferenceAction__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"VariableReferenceAction::nameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv nameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.name <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'name must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.VARIABLE_REFERENCE_ACTION___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = this.getName();\n\t\tfinal /*@NonInvalid*/ boolean status = name != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_name_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(nullValueActionEClass, source, new String[] { "documentation",
				"The NullValueAction returns the value \"null\" when it is evaluated." });
		addAnnotation(getNullValueAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"NullValueAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.NULL_VALUE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(unaryOperatorsEnumEEnum, source,
				new String[] { "documentation", "Enumeration of operators with a single operand." });
		addAnnotation(binaryOperatorsEnumEEnum, source,
				new String[] { "documentation", "Enumeration of operators with two operands." });
		addAnnotation(unaryOperationActionEClass, source,
				new String[] { "documentation", "Performs a unary operation on the operand." });
		addAnnotation(getUnaryOperationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"UnaryOperationAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.UNARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getUnaryOperationAction_Operator(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!UnaryOperationAction!operator" });
		addAnnotation(getUnaryOperationAction_Operand(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!UnaryOperationAction!operand" });
		addAnnotation(binaryOperationActionEClass, source,
				new String[] { "documentation", "Performs a binary operation on the operands." });
		addAnnotation(getBinaryOperationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"BinaryOperationAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.BINARY_OPERATION_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getBinaryOperationAction_Operator(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!BinaryOperationAction!operator" });
		addAnnotation(getBinaryOperationAction_Operand1(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!BinaryOperationAction!operand1" });
		addAnnotation(getBinaryOperationAction_Operand2(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!BinaryOperationAction!operand2" });
		addAnnotation(cloneActionEClass, source, new String[] { "documentation",
				"Clones the value returned by valueExpression. The value must be an EObject, so EcoreUtil.copy() is used to clone it." });
		addAnnotation(getCloneAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"CloneAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.CLONE_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getCloneAction_ValueExpression(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!CloneAction!valueExpression" });
		addAnnotation(callActionParameterEClass, source,
				new String[] { "documentation", "Specifies the value of a parameter of the containing CallAction." });
		addAnnotation(getCallActionParameter__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"CallActionParameter::nameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv nameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.name <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'name must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.CALL_ACTION_PARAMETER___NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = this.getName();\n\t\tfinal /*@NonInvalid*/ boolean status = name != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_name_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getCallActionParameter__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"CallActionParameter::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.CALL_ACTION_PARAMETER___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getCallActionParameter__NameUnique__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"CallActionParameter::nameUnique\";\ntry {\n\t/**\n\t *\n\t * inv nameUnique:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[1] = self.callAction.parameters->select(par | par.name = self.name)\n\t *           ->size() = 1\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.CALL_ACTION_PARAMETER___NAME_UNIQUE__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%de.mdelab.mlcallactions.ParameterizedCallAction%> callAction = this.getCallAction();\n\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlcallactions.CallActionParameter%>> parameters = callAction.getParameters();\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_parameters = idResolver.createOrderedSetOfAll(<%de.mdelab.mlcallactions.MlcallactionsTables%>.ORD_CLSSid_CallActionParameter, parameters);\n\t\t/*@Thrown*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue.Accumulator%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createOrderedSetAccumulatorValue(<%de.mdelab.mlcallactions.MlcallactionsTables%>.ORD_CLSSid_CallActionParameter);\n\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_par = BOXED_parameters.iterator();\n\t\t/*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> select;\n\t\twhile (true) {\n\t\t\tif (!ITERATOR_par.hasNext()) {\n\t\t\t\tselect = accumulator;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\t/*@NonInvalid*/ <%de.mdelab.mlcallactions.CallActionParameter%> par = (<%de.mdelab.mlcallactions.CallActionParameter%>)ITERATOR_par.next();\n\t\t\t/**\n\t\t\t * par.name = self.name\n\t\t\t */\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = par.getName();\n\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = this.getName();\n\t\t\tfinal /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t\t//\n\t\t\tif (eq) {\n\t\t\t\taccumulator.add(par);\n\t\t\t}\n\t\t}\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> size = <%org.eclipse.ocl.pivot.library.collection.CollectionSizeOperation%>.INSTANCE.evaluate(select);\n\t\tfinal /*@NonInvalid*/ boolean status = size.equals(<%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_1);\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getCallActionParameter_ValueExpression(), source, new String[] { "documentation",
				"The expressions that computes the parameter\'s value.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!CallActionParameter!valueExpression" });
		addAnnotation(getCallActionParameter_CallAction(), source, new String[] { "documentation",
				"The CallAction that contains this parameter.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!CallActionParameter!callAction" });
		addAnnotation(parameterizedCallActionEClass, source,
				new String[] { "documentation", "Superclass for call actions that may have parameters." });
		addAnnotation(getParameterizedCallAction_Parameters(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!ParameterizedCallAction!parameters" });
		addAnnotation(methodCallActionEClass, source, new String[] { "documentation",
				"Invokes a method using Java\'s reflection mechanism. If it is not a static method, a value for the implicit this parameter is required. The result of thisParameterValue is used for this purpose." });
		addAnnotation(getMethodCallAction__MethodClassNameSpecified__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"MethodCallAction::methodClassNameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv methodClassNameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[?] = self.methodClassName <> null and self.methodClassName <> \'\'\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'methodClassName must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.METHOD_CALL_ACTION___METHOD_CLASS_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> methodClassName = this.getMethodClassName();\n\t\tfinal /*@NonInvalid*/ boolean ne = !methodClassName.equals(<%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_);\n\t\tstatus = ne;\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_methodClassName_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getMethodCallAction__MethodNameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"MethodCallAction::methodNameSpecified\";\ntry {\n\t/**\n\t *\n\t * inv methodNameSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[?] = self.methodName <> null and self.methodName <> \'\'\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'methodName must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.METHOD_CALL_ACTION___METHOD_NAME_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%java.lang.Boolean%> status;\n\t\tfinal /*@NonInvalid*/ <%java.lang.String%> methodName = this.getMethodName();\n\t\tfinal /*@NonInvalid*/ boolean ne = !methodName.equals(<%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_);\n\t\tstatus = ne;\n\t\tfinal /*@NonInvalid*/ boolean eq = status == Boolean.TRUE;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (eq) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_methodName_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getMethodCallAction_MethodName(), source, new String[] { "documentation",
				"The name of the method to invoke.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!MethodCallAction!methodName" });
		addAnnotation(getMethodCallAction_MethodClassName(), source, new String[] { "documentation",
				"The class that contains the method to invoke.", "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!MethodCallAction!methodClassName" });
		addAnnotation(getMethodCallAction_ThisParameterValue(), source, new String[] { "documentation",
				"If the method is not static, the result of thisParameterValue is used as the \"this\" parameter.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!MethodCallAction!thisParameterValue" });
		addAnnotation(eOperationCallActionEClass, source, new String[] { "documentation",
				"Invokes the specified eOperation on the object returned by thisParameterValue." });
		addAnnotation(getEOperationCallAction__ParametersMatchOperation__DiagnosticChain_Map(), source, new String[] {
				"body",
				"final <%java.lang.String%> constraintName = \"EOperationCallAction::parametersMatchOperation\";\ntry {\n\t/**\n\t *\n\t * inv parametersMatchOperation:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = self.eOperation.eParameters->forAll(par |\n\t *             self.parameters->exists(par2 | par2.name = par.name) and\n\t *             self.parameters->any(par2 | par2.name = par.name).type = par.eType)\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{\n\t *               message = \'The provided parameters do not match the signature of eOperation \\\'\'.concat(\n\t *                 self.eOperation.toString())\n\t *               .concat(\'\\\'.\'), status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.EOPERATION_CALL_ACTION___PARAMETERS_MATCH_OPERATION__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_symbol_1;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EOperation%> eOperation = this.getEOperation();\n\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%org.eclipse.emf.ecore.EParameter%>> eParameters = eOperation.getEParameters();\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_eParameters = idResolver.createOrderedSetOfAll(<%de.mdelab.mlcallactions.MlcallactionsTables%>.ORD_CLSSid_EParameter, eParameters);\n\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_par = BOXED_eParameters.iterator();\n\t\t\t/*@Thrown*/ <%java.lang.Boolean%> status;\n\t\t\twhile (true) {\n\t\t\t\tif (!ITERATOR_par.hasNext()) {\n\t\t\t\t\tif (accumulator == null) {\n\t\t\t\t\t\tstatus = null;\n\t\t\t\t\t}\n\t\t\t\t\telse if (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator;\n\t\t\t\t\t}\n\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t\t/*@NonInvalid*/ <%org.eclipse.emf.ecore.EParameter%> par = (<%org.eclipse.emf.ecore.EParameter%>)ITERATOR_par.next();\n\t\t\t\t/**\n\t\t\t\t *\n\t\t\t\t * self.parameters->exists(par2 | par2.name = par.name) and\n\t\t\t\t * self.parameters->any(par2 | par2.name = par.name).type = par.eType\n\t\t\t\t */\n\t\t\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_and;\n\t\t\t\ttry {\n\t\t\t\t\tfinal /*@NonInvalid*/ <%java.util.List%><<%de.mdelab.mlcallactions.CallActionParameter%>> parameters = this.getParameters();\n\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.OrderedSetValue%> BOXED_parameters = idResolver.createOrderedSetOfAll(<%de.mdelab.mlcallactions.MlcallactionsTables%>.ORD_CLSSid_CallActionParameter, parameters);\n\t\t\t\t\t/*@Thrown*/ <%java.lang.Object%> accumulator_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_par2 = BOXED_parameters.iterator();\n\t\t\t\t\t/*@NonInvalid*/ <%java.lang.Boolean%> exists;\n\t\t\t\t\twhile (true) {\n\t\t\t\t\t\tif (!ITERATOR_par2.hasNext()) {\n\t\t\t\t\t\t\tif (accumulator_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)accumulator_0;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t}\n\t\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlcallactions.CallActionParameter%> par2 = (<%de.mdelab.mlcallactions.CallActionParameter%>)ITERATOR_par2.next();\n\t\t\t\t\t\t/**\n\t\t\t\t\t\t * par2.name = par.name\n\t\t\t\t\t\t */\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name = par2.getName();\n\t\t\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_0 = par.getName();\n\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0) : (name_0 == null);\n\t\t\t\t\t\t//\n\t\t\t\t\t\tif (eq) {\t\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t\t\texists = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse if (!eq) {\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\t\t\taccumulator_0 = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"exists\");\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> and;\n\t\t\t\t\tif (exists == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_eq_1;\n\t\t\t\t\t\ttry {\n\t\t\t\t\t\t\t<%java.util.Iterator%><<%java.lang.Object%>> ITERATOR_par2_0 = BOXED_parameters.iterator();\n\t\t\t\t\t\t\t/*@Thrown*/ <%de.mdelab.mlcallactions.CallActionParameter%> any;\n\t\t\t\t\t\t\twhile (true) {\n\t\t\t\t\t\t\t\tif (!ITERATOR_par2_0.hasNext()) {\n\t\t\t\t\t\t\t\t\tthrow new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(\"Nothing to return for \'\'any\'\'\");\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t\t/*@NonInvalid*/ <%de.mdelab.mlcallactions.CallActionParameter%> par2_0 = (<%de.mdelab.mlcallactions.CallActionParameter%>)ITERATOR_par2_0.next();\n\t\t\t\t\t\t\t\t/**\n\t\t\t\t\t\t\t\t * par2.name = par.name\n\t\t\t\t\t\t\t\t */\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_1 = par2_0.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> name_2 = par.getName();\n\t\t\t\t\t\t\t\tfinal /*@NonInvalid*/ boolean eq_0 = (name_1 != null) ? name_1.equals(name_2) : (name_2 == null);\n\t\t\t\t\t\t\t\t//\n\t\t\t\t\t\t\t\tif (eq_0) {\t\t\t// Carry on till something found\n\t\t\t\t\t\t\t\t\tany = par2_0;\n\t\t\t\t\t\t\t\t\tbreak;\n\t\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClassifier%> type = any.getType();\n\t\t\t\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> eType = par.getEType();\n\t\t\t\t\t\t\tfinal /*@Thrown*/ boolean eq_1 = (type != null) ? type.equals(eType) : (eType == null);\n\t\t\t\t\t\t\tCAUGHT_eq_1 = eq_1;\n\t\t\t\t\t\t}\n\t\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\t\tCAUGHT_eq_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t\t}\n\t\t\t\t\t\tif (CAUGHT_eq_1 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tif (CAUGHT_eq_1 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\t\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_eq_1;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif (exists == null) {\n\t\t\t\t\t\t\t\tand = null;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\telse {\n\t\t\t\t\t\t\t\tand = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tCAUGHT_and = and;\n\t\t\t\t}\n\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\tCAUGHT_and = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t}\n\t\t\t\t//\n\t\t\t\tif (CAUGHT_and == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\t\t\t\t\t// Normal unsuccessful body evaluation result\n\t\t\t\t\tstatus = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\tbreak;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\t\t\t\t// Normal successful body evaluation result\n\t\t\t\t\t;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n\t\t\t\t\tif (accumulator == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\taccumulator = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t\telse if (CAUGHT_and instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n\t\t\t\t\taccumulator = CAUGHT_and;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n\t\t\t\t}\n\t\t\t\telse {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n\t\t\t\t\taccumulator = new <%org.eclipse.ocl.pivot.values.InvalidValueException%>(<%org.eclipse.ocl.pivot.messages.PivotMessages%>.NonBooleanBody, \"forAll\");\n\t\t\t\t}\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ boolean eq_2 = status == Boolean.TRUE;\n\t\t\t/*@Thrown*/ <%java.lang.Object%> symbol_1;\n\t\t\tif (eq_2) {\n\t\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> toString = <%org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation%>.INSTANCE.evaluate(eOperation);\n\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> concat = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(<%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_The_32_provided_32_parameters_32_do_32_not_32_match_32_the_32_signature_32_of_32_eOperation, toString);\n\t\t\t\tfinal /*@NonInvalid*/ <%java.lang.String%> concat_0 = <%org.eclipse.ocl.pivot.library.string.StringConcatOperation%>.INSTANCE.evaluate(concat, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR__39_);\n\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, concat_0, status);\n\t\t\t\tsymbol_1 = symbol_0;\n\t\t\t}\n\t\t\tCAUGHT_symbol_1 = symbol_1;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_symbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, CAUGHT_symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getEOperationCallAction_ThisParameterValue(), source, new String[] { "documentation",
				"If the method is not static, the result of thisParameterValue is used as the \"this\" parameter.",
				"get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!EOperationCallAction!thisParameterValue" });
		addAnnotation(getEOperationCallAction_EOperation(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!EOperationCallAction!eOperation" });
		addAnnotation(newObjectActionEClass, source, new String[] { "documentation",
				"Creates a new object of the specified type. If the type is an EClass, the appropriate factory is used and no parameters have to be present. If the type is an EDataType, the parameters are used to select the appropriate constructor." });
		addAnnotation(getNewObjectAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"NewObjectAction::typeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv typeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let status : Boolean[1] = self.type <> null\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must be specified.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.NEW_OBJECT_ACTION___TYPE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_2;\n\tif (le) {\n\t\tsymbol_2 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\tfinal /*@NonInvalid*/ boolean status = type != null;\n\t\t/*@NonInvalid*/ <%java.lang.Object%> symbol_1;\n\t\tif (status) {\n\t\t\tsymbol_1 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t}\n\t\telse {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_be_32_specified, status);\n\t\t\tsymbol_1 = symbol_0;\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, symbol_1, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_2 = logDiagnostic;\n\t}\n\treturn symbol_2;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(getNewObjectAction__TypeNotAbstract__DiagnosticChain_Map(), source, new String[] { "body",
				"final <%java.lang.String%> constraintName = \"NewObjectAction::typeNotAbstract\";\ntry {\n\t/**\n\t *\n\t * inv typeNotAbstract:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity <= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.type <> null\n\t *           then\n\t *             if self.type.oclIsKindOf(ecore::EClass)\n\t *             then not self.type.oclAsType(ecore::EClass).abstract\n\t *             else null\n\t *             endif\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else Tuple{message = \'type must not be abstract.\', status = status}\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t */\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.evaluation.Executor%> executor = <%org.eclipse.ocl.pivot.utilities.PivotUtil%>.getExecutor(this, context);\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.ids.IdResolver%> idResolver = executor.getIdResolver();\n\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.values.IntegerValue%> severity_0 = <%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%>.INSTANCE.evaluate(executor, <%de.mdelab.mlcallactions.MlcallactionsPackage%>.Literals.NEW_OBJECT_ACTION___TYPE_NOT_ABSTRACT__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid*/ boolean le = <%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%>.INSTANCE.evaluate(executor, severity_0, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t/*@NonInvalid*/ boolean symbol_4;\n\tif (le) {\n\t\tsymbol_4 = true;\n\t}\n\telse {\n\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_symbol_3;\n\t\ttry {\n\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.emf.ecore.EClassifier%> type = this.getType();\n\t\t\tfinal /*@NonInvalid*/ boolean ne = type != null;\n\t\t\t/*@Thrown*/ <%java.lang.Boolean%> status;\n\t\t\tif (ne) {\n\t\t\t\tfinal /*@NonInvalid*/ <%org.eclipse.ocl.pivot.Class%> TYP_ecore_c_c_EClass = idResolver.getClass(<%de.mdelab.mlcallactions.MlcallactionsTables%>.CLSSid_EClass, null);\n\t\t\t\tfinal /*@Thrown*/ boolean oclIsKindOf = <%org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation%>.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass).booleanValue();\n\t\t\t\t/*@Thrown*/ <%java.lang.Boolean%> symbol_1;\n\t\t\t\tif (oclIsKindOf) {\n\t\t\t\t\t/*@Caught*/ <%java.lang.Object%> CAUGHT_symbol_0;\n\t\t\t\t\ttry {\n\t\t\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.emf.ecore.EClass%> oclAsType = (<%org.eclipse.emf.ecore.EClass%>)<%org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation%>.INSTANCE.evaluate(executor, type, TYP_ecore_c_c_EClass);\n\t\t\t\t\t\tfinal /*@Thrown*/ boolean symbol_0 = oclAsType.isAbstract();\n\t\t\t\t\t\tCAUGHT_symbol_0 = symbol_0;\n\t\t\t\t\t}\n\t\t\t\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\t\t\t\tCAUGHT_symbol_0 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t\t\t\t}\n\t\t\t\t\tif (CAUGHT_symbol_0 instanceof <%org.eclipse.ocl.pivot.values.InvalidValueException%>) {\n\t\t\t\t\t\tthrow (<%org.eclipse.ocl.pivot.values.InvalidValueException%>)CAUGHT_symbol_0;\n\t\t\t\t\t}\n\t\t\t\t\tfinal /*@Thrown*/ <%java.lang.Boolean%> not;\n\t\t\t\t\tif (CAUGHT_symbol_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE) {\n\t\t\t\t\t\tnot = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t\t\t}\n\t\t\t\t\telse {\n\t\t\t\t\t\tif (CAUGHT_symbol_0 == <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE) {\n\t\t\t\t\t\t\tnot = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.FALSE_VALUE;\n\t\t\t\t\t\t}\n\t\t\t\t\t\telse {\n\t\t\t\t\t\t\tnot = null;\n\t\t\t\t\t\t}\n\t\t\t\t\t}\n\t\t\t\t\tsymbol_1 = not;\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tsymbol_1 = null;\n\t\t\t\t}\n\t\t\t\tstatus = symbol_1;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tstatus = null;\n\t\t\t}\n\t\t\tfinal /*@Thrown*/ boolean eq = status == Boolean.TRUE;\n\t\t\t/*@Thrown*/ <%java.lang.Object%> symbol_3;\n\t\t\tif (eq) {\n\t\t\t\tsymbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.TRUE_VALUE;\n\t\t\t}\n\t\t\telse {\n\t\t\t\tfinal /*@Thrown*/ <%org.eclipse.ocl.pivot.values.TupleValue%> symbol_2 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createTupleOfEach(<%de.mdelab.mlcallactions.MlcallactionsTables%>.TUPLid_, <%de.mdelab.mlcallactions.MlcallactionsTables%>.STR_type_32_must_32_not_32_be_32_abstract, status);\n\t\t\t\tsymbol_3 = symbol_2;\n\t\t\t}\n\t\t\tCAUGHT_symbol_3 = symbol_3;\n\t\t}\n\t\tcatch (<%java.lang.Exception%> e) {\n\t\t\tCAUGHT_symbol_3 = <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.createInvalidValue(e);\n\t\t}\n\t\tfinal /*@NonInvalid*/ boolean logDiagnostic = <%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%>.INSTANCE.evaluate(executor, <%org.eclipse.ocl.pivot.ids.TypeId%>.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, CAUGHT_symbol_3, <%de.mdelab.mlcallactions.MlcallactionsTables%>.INT_0).booleanValue();\n\t\tsymbol_4 = logDiagnostic;\n\t}\n\treturn symbol_4;\n}\ncatch (<%java.lang.Throwable%> e) {\n\treturn <%org.eclipse.ocl.pivot.utilities.ValueUtil%>.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}" });
		addAnnotation(eObjectReferenceActionEClass, source,
				new String[] { "documentation", "References an EObject from an EMF model." });
		addAnnotation(getEObjectReferenceAction_EObject(), source, new String[] { "get",
				"throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlexpressions/mlcallactions/1.0!EObjectReferenceAction!eObject" });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";
		addAnnotation(getLiteralDeclarationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getLiteralDeclarationAction__LitteralNotNull__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'literal must not be null.\',\n\tstatus : Boolean = \n\t\tself.literal <> null and self.literal <> \'\'\n}.status" });
		addAnnotation(getVariableDeclarationAction__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'name must be specified.\',\n\tstatus : Boolean = \n\t\tself.name <> null\n}.status" });
		addAnnotation(getVariableDeclarationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getVariableDeclarationAction__ValueExpressionSpecified__DiagnosticChain_Map(), source,
				new String[] { "body",
						"Tuple {\n\tmessage : String = \'valueExpression must be specified.\',\n\tstatus : Boolean = \n\t\tself.valueExpression <> null\n}.status" });
		addAnnotation(getVariableReferenceAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getVariableReferenceAction__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'name must be specified.\',\n\tstatus : Boolean = \n\t\tself.name <> null\n}.status" });
		addAnnotation(getNullValueAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getUnaryOperationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getBinaryOperationAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getCloneAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getCallActionParameter__NameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'name must be specified.\',\n\tstatus : Boolean = \n\t\tself.name <> null\n}.status" });
		addAnnotation(getCallActionParameter__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getCallActionParameter__NameUnique__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.callAction.parameters->select( par | par.name = self.name )->size() = 1\n}.status" });
		addAnnotation(getMethodCallAction__MethodClassNameSpecified__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'methodClassName must be specified.\',\n\tstatus : Boolean = \n\t\tself.methodClassName <> null and self.methodClassName <> \'\'\n}.status" });
		addAnnotation(getMethodCallAction__MethodNameSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'methodName must be specified.\',\n\tstatus : Boolean = \n\t\tself.methodName <> null and self.methodName <> \'\'\n}.status" });
		addAnnotation(getEOperationCallAction__ParametersMatchOperation__DiagnosticChain_Map(), source, new String[] {
				"body",
				"Tuple {\n\tmessage : String = \'The provided parameters do not match the signature of eOperation \\\'\'.concat( self.eOperation.toString() ).concat( \'\\\'.\' ) ,\n\tstatus : Boolean = \n\t\tself.eOperation.eParameters->forAll( par | self.parameters->exists( par2 | par2.name = par.name) and self.parameters->any( par2 | par2.name = par.name ).type = par.eType)\n}.status" });
		addAnnotation(getNewObjectAction__TypeSpecified__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must be specified.\',\n\tstatus : Boolean = \n\t\tself.type <> null\n}.status" });
		addAnnotation(getNewObjectAction__TypeNotAbstract__DiagnosticChain_Map(), source, new String[] { "body",
				"Tuple {\n\tmessage : String = \'type must not be abstract.\',\n\tstatus : Boolean = \n\t\tif self.type <> null then\n\t\t\tif self.type.oclIsKindOf( ecore::EClass ) then\n\t\t\t\tnot self.type.oclAsType( ecore::EClass ).abstract\n\t\t\telse\n\t\t\t\tnull\n\t\t\tendif\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status" });
	}

} // MlcallactionsPackageImpl
