/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.provider.MLExpressionItemProvider;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlcallactions.CallActionExpression} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CallActionExpressionItemProvider extends MLExpressionItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CallActionExpressionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns CallActionExpression.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/CallActionExpression"));
	}
	
	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	public String getText(final Object object) {
		String label = "";

		final ComposedAdapterFactory factory = new ComposedAdapterFactory(
				EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

		final CallActionExpression expression = (CallActionExpression) object;

		if (expression.getCallActions().isEmpty()) {
			label += "[null]";
		} else {
			label += ((IItemLabelProvider) factory.adapt(expression.getCallActions().get(0), IItemLabelProvider.class))
					.getText(expression.getCallActions().get(0));

			if (expression.getCallActions().size() > 1) {
				label += "...";
			}
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(CallActionExpression.class)) {
		case MlcallactionsPackage.CALL_ACTION_EXPRESSION__CALL_ACTIONS:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createLiteralDeclarationAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createVariableDeclarationAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createVariableReferenceAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createNullValueAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createUnaryOperationAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createBinaryOperationAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createCloneAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createMethodCallAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createEOperationCallAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createNewObjectAction()));

		newChildDescriptors.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createEObjectReferenceAction()));
	}

	@Override
	public Object getFont(final Object object) {
		return IItemFontProvider.ITALIC_FONT;
	}
}
