/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlannotations.MlannotationsFactory;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.provider.MLElementWithUUIDItemProvider;
import de.mdelab.mlexpressions.MlexpressionsFactory;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlcallactions.CallActionParameter} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CallActionParameterItemProvider extends MLElementWithUUIDItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CallActionParameterItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_MLNamedElement_name_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_MLNamedElement_name_feature",
								"_UI_MLNamedElement_type"),
						MlcorePackage.Literals.ML_NAMED_ELEMENT__NAME, true, false, false,
						ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Type feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
						getResourceLocator(), getString("_UI_MLTypedElement_type_feature"),
						getString("_UI_PropertyDescriptor_description", "_UI_MLTypedElement_type_feature",
								"_UI_MLTypedElement_type"),
						MlcorePackage.Literals.ML_TYPED_ELEMENT__TYPE, true, false, true, null, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS);
			childrenFeatures.add(MlcallactionsPackage.Literals.CALL_ACTION_PARAMETER__VALUE_EXPRESSION);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns CallActionParameter.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/CallActionParameter"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = "";

		final CallActionParameter parameter = (CallActionParameter) object;

		if (parameter.getName() != null && !"".equals(parameter.getName())) {
			label += parameter.getName();
		} else {
			label += "[null]";
		}

		label += " : ";

		if (parameter.getType() != null) {
			label += parameter.getType().getName();
		} else {
			label += "[null]";
		}

		label += " := ";

		if (parameter.getValueExpression() != null) {
			final ComposedAdapterFactory factory = new ComposedAdapterFactory(
					EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

			label += ((IItemLabelProvider) factory.adapt(parameter.getValueExpression(), IItemLabelProvider.class))
					.getText(parameter.getValueExpression());
		} else {
			label += "[null]";
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(CallActionParameter.class)) {
		case MlcallactionsPackage.CALL_ACTION_PARAMETER__NAME:
		case MlcallactionsPackage.CALL_ACTION_PARAMETER__TYPE:
		case MlcallactionsPackage.CALL_ACTION_PARAMETER__CALL_ACTION:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case MlcallactionsPackage.CALL_ACTION_PARAMETER__ANNOTATIONS:
		case MlcallactionsPackage.CALL_ACTION_PARAMETER__VALUE_EXPRESSION:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(MlcorePackage.Literals.ML_ANNOTATED_ELEMENT__ANNOTATIONS,
				MlannotationsFactory.eINSTANCE.createMLAnnotation()));

		newChildDescriptors
				.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_PARAMETER__VALUE_EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

		newChildDescriptors
				.add(createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_PARAMETER__VALUE_EXPRESSION,
						MlexpressionsFactory.eINSTANCE.createMLStringExpression()));
	}

}
