/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlcallactions.EObjectReferenceAction} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class EObjectReferenceActionItemProvider extends CallActionItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EObjectReferenceActionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addEObjectPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the EObject feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addEObjectPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_EObjectReferenceAction_eObject_feature"),
				getString("_UI_PropertyDescriptor_description", "_UI_EObjectReferenceAction_eObject_feature",
						"_UI_EObjectReferenceAction_type"),
				MlcallactionsPackage.Literals.EOBJECT_REFERENCE_ACTION__EOBJECT, true, false, true, null, null, null));
	}

	/**
	 * This returns EObjectReferenceAction.gif.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/EObjectReferenceAction"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object) {
		String label = "";

		final EObjectReferenceAction action = (EObjectReferenceAction) object;

		if (action.getEObject() != null) {
			if (action.getEObject().eResource() != null) {
				label += action.getEObject().eResource().getURI().toString() + "#";
			}

			final ComposedAdapterFactory factory = new ComposedAdapterFactory(
					EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

			label += ((IItemLabelProvider) factory.adapt(action.getEObject(), IItemLabelProvider.class))
					.getText(action.getEObject());
		} else {
			label += "[null]";
		}

		label += " : ";

		if (action.getType() != null) {
			label += action.getType().getName();
		} else {
			label += "[null]";
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
