/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ChildCreationExtenderManager;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.util.MlcallactionsAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public class MlcallactionsItemProviderAdapterFactory extends MlcallactionsAdapterFactory
		implements ComposeableAdapterFactory, IChangeNotifier, IDisposable, IChildCreationExtender {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement
	 * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This helps manage the child creation extenders.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChildCreationExtenderManager childCreationExtenderManager = new ChildCreationExtenderManager(
			MlcallactionsEditPlugin.INSTANCE, MlcallactionsPackage.eNS_URI);

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public MlcallactionsItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
		supportedTypes.add(ITableItemLabelProvider.class);
		supportedTypes.add(ITableItemColorProvider.class);
		supportedTypes.add(ITableItemFontProvider.class);
		supportedTypes.add(IItemColorProvider.class);
		supportedTypes.add(IItemFontProvider.class);
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CallActionExpression} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CallActionExpressionItemProvider callActionExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.CallActionExpression}.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallActionExpressionAdapter() {
		if (callActionExpressionItemProvider == null) {
			callActionExpressionItemProvider = new CallActionExpressionItemProvider(this);
		}

		return callActionExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.LiteralDeclarationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LiteralDeclarationActionItemProvider literalDeclarationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.LiteralDeclarationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createLiteralDeclarationActionAdapter() {
		if (literalDeclarationActionItemProvider == null) {
			literalDeclarationActionItemProvider = new LiteralDeclarationActionItemProvider(this);
		}

		return literalDeclarationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.VariableDeclarationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected VariableDeclarationActionItemProvider variableDeclarationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.VariableDeclarationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createVariableDeclarationActionAdapter() {
		if (variableDeclarationActionItemProvider == null) {
			variableDeclarationActionItemProvider = new VariableDeclarationActionItemProvider(this);
		}

		return variableDeclarationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.VariableReferenceAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected VariableReferenceActionItemProvider variableReferenceActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.VariableReferenceAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createVariableReferenceActionAdapter() {
		if (variableReferenceActionItemProvider == null) {
			variableReferenceActionItemProvider = new VariableReferenceActionItemProvider(this);
		}

		return variableReferenceActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.NullValueAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected NullValueActionItemProvider nullValueActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.NullValueAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNullValueActionAdapter() {
		if (nullValueActionItemProvider == null) {
			nullValueActionItemProvider = new NullValueActionItemProvider(this);
		}

		return nullValueActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.UnaryOperationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected UnaryOperationActionItemProvider unaryOperationActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.UnaryOperationAction}.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUnaryOperationActionAdapter() {
		if (unaryOperationActionItemProvider == null) {
			unaryOperationActionItemProvider = new UnaryOperationActionItemProvider(this);
		}

		return unaryOperationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected BinaryOperationActionItemProvider binaryOperationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createBinaryOperationActionAdapter() {
		if (binaryOperationActionItemProvider == null) {
			binaryOperationActionItemProvider = new BinaryOperationActionItemProvider(this);
		}

		return binaryOperationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CloneAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CloneActionItemProvider cloneActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.CloneAction}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCloneActionAdapter() {
		if (cloneActionItemProvider == null) {
			cloneActionItemProvider = new CloneActionItemProvider(this);
		}

		return cloneActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CallActionParameter} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CallActionParameterItemProvider callActionParameterItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.CallActionParameter}.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallActionParameterAdapter() {
		if (callActionParameterItemProvider == null) {
			callActionParameterItemProvider = new CallActionParameterItemProvider(this);
		}

		return callActionParameterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.MethodCallAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MethodCallActionItemProvider methodCallActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.MethodCallAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMethodCallActionAdapter() {
		if (methodCallActionItemProvider == null) {
			methodCallActionItemProvider = new MethodCallActionItemProvider(this);
		}

		return methodCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.EOperationCallAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EOperationCallActionItemProvider eOperationCallActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.EOperationCallAction}.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEOperationCallActionAdapter() {
		if (eOperationCallActionItemProvider == null) {
			eOperationCallActionItemProvider = new EOperationCallActionItemProvider(this);
		}

		return eOperationCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.NewObjectAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected NewObjectActionItemProvider newObjectActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.NewObjectAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNewObjectActionAdapter() {
		if (newObjectActionItemProvider == null) {
			newObjectActionItemProvider = new NewObjectActionItemProvider(this);
		}

		return newObjectActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.EObjectReferenceAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EObjectReferenceActionItemProvider eObjectReferenceActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.EObjectReferenceAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createEObjectReferenceActionAdapter() {
		if (eObjectReferenceActionItemProvider == null) {
			eObjectReferenceActionItemProvider = new EObjectReferenceActionItemProvider(this);
		}

		return eObjectReferenceActionItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public List<IChildCreationExtender> getChildCreationExtenders() {
		return childCreationExtenderManager.getChildCreationExtenders();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<?> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
		return childCreationExtenderManager.getNewChildDescriptors(object, editingDomain);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return childCreationExtenderManager;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to
	 * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void dispose() {
		if (callActionExpressionItemProvider != null)
			callActionExpressionItemProvider.dispose();
		if (literalDeclarationActionItemProvider != null)
			literalDeclarationActionItemProvider.dispose();
		if (variableDeclarationActionItemProvider != null)
			variableDeclarationActionItemProvider.dispose();
		if (variableReferenceActionItemProvider != null)
			variableReferenceActionItemProvider.dispose();
		if (nullValueActionItemProvider != null)
			nullValueActionItemProvider.dispose();
		if (unaryOperationActionItemProvider != null)
			unaryOperationActionItemProvider.dispose();
		if (binaryOperationActionItemProvider != null)
			binaryOperationActionItemProvider.dispose();
		if (cloneActionItemProvider != null)
			cloneActionItemProvider.dispose();
		if (callActionParameterItemProvider != null)
			callActionParameterItemProvider.dispose();
		if (methodCallActionItemProvider != null)
			methodCallActionItemProvider.dispose();
		if (eOperationCallActionItemProvider != null)
			eOperationCallActionItemProvider.dispose();
		if (newObjectActionItemProvider != null)
			newObjectActionItemProvider.dispose();
		if (eObjectReferenceActionItemProvider != null)
			eObjectReferenceActionItemProvider.dispose();
	}

}
