/**
 */
package de.mdelab.mlcallactions.util;

import de.mdelab.mlcallactions.*;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.CloneAction;
import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.LiteralDeclarationAction;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.NewObjectAction;
import de.mdelab.mlcallactions.NullValueAction;
import de.mdelab.mlcallactions.ParameterizedCallAction;
import de.mdelab.mlcallactions.UnaryOperationAction;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcallactions.VariableReferenceAction;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see de.mdelab.mlcallactions.MlcallactionsPackage
 * @generated
 */
public class MlcallactionsSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static MlcallactionsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public MlcallactionsSwitch() {
		if (modelPackage == null) {
			modelPackage = MlcallactionsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case MlcallactionsPackage.CALL_ACTION_EXPRESSION: {
			CallActionExpression callActionExpression = (CallActionExpression) theEObject;
			T result = caseCallActionExpression(callActionExpression);
			if (result == null)
				result = caseMLExpression(callActionExpression);
			if (result == null)
				result = caseMLElementWithUUID(callActionExpression);
			if (result == null)
				result = caseMLAnnotatedElement(callActionExpression);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.CALL_ACTION: {
			CallAction callAction = (CallAction) theEObject;
			T result = caseCallAction(callAction);
			if (result == null)
				result = caseMLElementWithUUID(callAction);
			if (result == null)
				result = caseMLAnnotatedElement(callAction);
			if (result == null)
				result = caseMLTypedElement(callAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.LITERAL_DECLARATION_ACTION: {
			LiteralDeclarationAction literalDeclarationAction = (LiteralDeclarationAction) theEObject;
			T result = caseLiteralDeclarationAction(literalDeclarationAction);
			if (result == null)
				result = caseCallAction(literalDeclarationAction);
			if (result == null)
				result = caseMLElementWithUUID(literalDeclarationAction);
			if (result == null)
				result = caseMLAnnotatedElement(literalDeclarationAction);
			if (result == null)
				result = caseMLTypedElement(literalDeclarationAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION: {
			VariableDeclarationAction variableDeclarationAction = (VariableDeclarationAction) theEObject;
			T result = caseVariableDeclarationAction(variableDeclarationAction);
			if (result == null)
				result = caseCallAction(variableDeclarationAction);
			if (result == null)
				result = caseMLNamedElement(variableDeclarationAction);
			if (result == null)
				result = caseMLElementWithUUID(variableDeclarationAction);
			if (result == null)
				result = caseMLAnnotatedElement(variableDeclarationAction);
			if (result == null)
				result = caseMLTypedElement(variableDeclarationAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.VARIABLE_REFERENCE_ACTION: {
			VariableReferenceAction variableReferenceAction = (VariableReferenceAction) theEObject;
			T result = caseVariableReferenceAction(variableReferenceAction);
			if (result == null)
				result = caseCallAction(variableReferenceAction);
			if (result == null)
				result = caseMLNamedElement(variableReferenceAction);
			if (result == null)
				result = caseMLElementWithUUID(variableReferenceAction);
			if (result == null)
				result = caseMLAnnotatedElement(variableReferenceAction);
			if (result == null)
				result = caseMLTypedElement(variableReferenceAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.NULL_VALUE_ACTION: {
			NullValueAction nullValueAction = (NullValueAction) theEObject;
			T result = caseNullValueAction(nullValueAction);
			if (result == null)
				result = caseCallAction(nullValueAction);
			if (result == null)
				result = caseMLElementWithUUID(nullValueAction);
			if (result == null)
				result = caseMLAnnotatedElement(nullValueAction);
			if (result == null)
				result = caseMLTypedElement(nullValueAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.UNARY_OPERATION_ACTION: {
			UnaryOperationAction unaryOperationAction = (UnaryOperationAction) theEObject;
			T result = caseUnaryOperationAction(unaryOperationAction);
			if (result == null)
				result = caseCallAction(unaryOperationAction);
			if (result == null)
				result = caseMLElementWithUUID(unaryOperationAction);
			if (result == null)
				result = caseMLAnnotatedElement(unaryOperationAction);
			if (result == null)
				result = caseMLTypedElement(unaryOperationAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.BINARY_OPERATION_ACTION: {
			BinaryOperationAction binaryOperationAction = (BinaryOperationAction) theEObject;
			T result = caseBinaryOperationAction(binaryOperationAction);
			if (result == null)
				result = caseCallAction(binaryOperationAction);
			if (result == null)
				result = caseMLElementWithUUID(binaryOperationAction);
			if (result == null)
				result = caseMLAnnotatedElement(binaryOperationAction);
			if (result == null)
				result = caseMLTypedElement(binaryOperationAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.CLONE_ACTION: {
			CloneAction cloneAction = (CloneAction) theEObject;
			T result = caseCloneAction(cloneAction);
			if (result == null)
				result = caseCallAction(cloneAction);
			if (result == null)
				result = caseMLElementWithUUID(cloneAction);
			if (result == null)
				result = caseMLAnnotatedElement(cloneAction);
			if (result == null)
				result = caseMLTypedElement(cloneAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.CALL_ACTION_PARAMETER: {
			CallActionParameter callActionParameter = (CallActionParameter) theEObject;
			T result = caseCallActionParameter(callActionParameter);
			if (result == null)
				result = caseMLElementWithUUID(callActionParameter);
			if (result == null)
				result = caseMLAnnotatedElement(callActionParameter);
			if (result == null)
				result = caseMLNamedElement(callActionParameter);
			if (result == null)
				result = caseMLTypedElement(callActionParameter);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.PARAMETERIZED_CALL_ACTION: {
			ParameterizedCallAction parameterizedCallAction = (ParameterizedCallAction) theEObject;
			T result = caseParameterizedCallAction(parameterizedCallAction);
			if (result == null)
				result = caseCallAction(parameterizedCallAction);
			if (result == null)
				result = caseMLElementWithUUID(parameterizedCallAction);
			if (result == null)
				result = caseMLAnnotatedElement(parameterizedCallAction);
			if (result == null)
				result = caseMLTypedElement(parameterizedCallAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.METHOD_CALL_ACTION: {
			MethodCallAction methodCallAction = (MethodCallAction) theEObject;
			T result = caseMethodCallAction(methodCallAction);
			if (result == null)
				result = caseParameterizedCallAction(methodCallAction);
			if (result == null)
				result = caseCallAction(methodCallAction);
			if (result == null)
				result = caseMLElementWithUUID(methodCallAction);
			if (result == null)
				result = caseMLAnnotatedElement(methodCallAction);
			if (result == null)
				result = caseMLTypedElement(methodCallAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.EOPERATION_CALL_ACTION: {
			EOperationCallAction eOperationCallAction = (EOperationCallAction) theEObject;
			T result = caseEOperationCallAction(eOperationCallAction);
			if (result == null)
				result = caseParameterizedCallAction(eOperationCallAction);
			if (result == null)
				result = caseCallAction(eOperationCallAction);
			if (result == null)
				result = caseMLElementWithUUID(eOperationCallAction);
			if (result == null)
				result = caseMLAnnotatedElement(eOperationCallAction);
			if (result == null)
				result = caseMLTypedElement(eOperationCallAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.NEW_OBJECT_ACTION: {
			NewObjectAction newObjectAction = (NewObjectAction) theEObject;
			T result = caseNewObjectAction(newObjectAction);
			if (result == null)
				result = caseParameterizedCallAction(newObjectAction);
			if (result == null)
				result = caseCallAction(newObjectAction);
			if (result == null)
				result = caseMLElementWithUUID(newObjectAction);
			if (result == null)
				result = caseMLAnnotatedElement(newObjectAction);
			if (result == null)
				result = caseMLTypedElement(newObjectAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case MlcallactionsPackage.EOBJECT_REFERENCE_ACTION: {
			EObjectReferenceAction eObjectReferenceAction = (EObjectReferenceAction) theEObject;
			T result = caseEObjectReferenceAction(eObjectReferenceAction);
			if (result == null)
				result = caseCallAction(eObjectReferenceAction);
			if (result == null)
				result = caseMLElementWithUUID(eObjectReferenceAction);
			if (result == null)
				result = caseMLAnnotatedElement(eObjectReferenceAction);
			if (result == null)
				result = caseMLTypedElement(eObjectReferenceAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call Action Expression</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call Action Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallActionExpression(CallActionExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call Action</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallAction(CallAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Literal Declaration Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Literal Declaration Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLiteralDeclarationAction(LiteralDeclarationAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Variable Declaration Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Variable Declaration Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariableDeclarationAction(VariableDeclarationAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Variable Reference Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Variable Reference Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariableReferenceAction(VariableReferenceAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Null Value Action</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Null Value Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNullValueAction(NullValueAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Unary Operation Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Unary Operation Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUnaryOperationAction(UnaryOperationAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Binary Operation Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Binary Operation Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBinaryOperationAction(BinaryOperationAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Clone Action</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Clone Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCloneAction(CloneAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call Action Parameter</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call Action Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallActionParameter(CallActionParameter object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Parameterized Call Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Parameterized Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseParameterizedCallAction(ParameterizedCallAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Method Call Action</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Method Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMethodCallAction(MethodCallAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EOperation Call Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EOperation Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEOperationCallAction(EOperationCallAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>New Object Action</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>New Object Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNewObjectAction(NewObjectAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject Reference Action</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject Reference Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEObjectReferenceAction(EObjectReferenceAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Element With UUID</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLElementWithUUID(MLElementWithUUID object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLAnnotatedElement(MLAnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Expression</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLExpression(MLExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLTypedElement(MLTypedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ML Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLNamedElement(MLNamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} // MlcallactionsSwitch
